import { createApp, defineAsyncComponent } from '/static/js/vue.esm-browser.min.js'
import { createStore } from '/static/js/vuex.esm-browser.js'



// Create a new store instance.
const store = createStore({
  state () {
    return {
      loggedIn: false,
      username: '',
      password: '',
    }
  },
  mutations: {
      logIn(state, payload) {
          state.loggedIn = true
          state.username = payload.username
          state.password = payload.password
      },
      logOut(state) {
          state.loggedIn = false
      }
  },

  devtools: false,

})

var app = createApp({
    components: {
        'CounterList': defineAsyncComponent( () => import('/static/vue/counterlist.js') ),
        'UserLogin': defineAsyncComponent( () => import('/static/vue/userlogin.js') ),
    },

    template: ` <CounterList></CounterList>
    <UserLogin></UserLogin>
    `
})
app.use(store)
app.mount('#app')
