const template = `
<div class="counter">Fila {{queue_desc}}: <div class="counter-number">{{counter}}</div>
<div v-if="loggedIn"><button @click="callNext">Prossimo</button></div></div>
    `


export default {
    props: ["queue_num"],
    data() {
        var me = this;
        do_websocket(parseInt(me.queue_num, 10), function(new_value) {
            me.counter = new_value
        })
        return  { counter: -1 }
    },
    template: template,
    computed: {
        queue_desc: function() {
            return printToLetter(parseInt(this.queue_num, 10) + 1)
        },

        loggedIn() {
            return this.$store.state.loggedIn
        }
    },

    methods: {
        callNext() {
            let headers = new Headers()
            let username = this.$store.state.username
            let password = this.$store.state.password
            headers.set('Authorization', 'Basic ' + btoa(username + ":" + password))
            fetch('/v1/counter/' + this.queue_num + '/increment', {method: 'POST', headers: headers})
        }
    }
}

function get_url(cid)
{
    var url = "";
    if(window.location.protocol == "http:") {
        url += "ws://"
    } else {
        url = "wss://"
    }
    url += window.location.host + '/v1/ws/counter/';
    url += cid
    return url;
}

function do_websocket(cid, cb_on_new_value)
{
    const socket = new WebSocket(get_url(cid));
    socket.onmessage = function(evt) {
        var msg = JSON.parse(evt.data)
        cb_on_new_value(msg.value)
    }
    socket.onclose = function() {
        setTimeout(do_websocket, 3000)
    }
    socket.onerror = socket.onclose
}

/* thanks, https://stackoverflow.com/a/60033403 */
var alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
function printToLetter(number, recursive){
    number--
    if(number < 0) {
        if(recursive === true) {
            return alphabet[alphabet.length - 1]
        } else {
            return 'ø'
        }
    }
    if(number < alphabet.length) {
        return alphabet[number]
    }
    var remainder = number % alphabet.length
    var quotient = Math.floor((number-1)/alphabet.length)
    return printToLetter(quotient, true) + printToLetter(remainder, true)
}
