import { defineAsyncComponent } from '/static/js/vue.esm-browser.min.js'

const template = `
<div class="counters">
    <CounterController v-for="q in queues" :queue_num="q"></CounterController>
    </div>
            `

export default {
    template: template,

    components: {
        'CounterController': defineAsyncComponent( () => import('/static/vue/counter.js') ),
    },

    data() {
        return {
            queue_count: 0,
        }
    },

    mounted: function () {
        this.updateGlobalProperties()
    },

    methods: {
        updateGlobalProperties() {
            var me = this
            fetch('/v1/counter/')
            .then((response) => response.json())
            .then(function(data) {
                me.queue_count = data.counters
            })
        }
    },

    computed: {
        queues() {
            return range(0, this.queue_count-1)
        }
    },

}

function range(start, end) {
    var ans = [];
    for (let i = start; i <= end; i++) {
        ans.push(i);
    }
    return ans;
}

